# NaiveTicket
.

The second Objects lab,from the BlueJ book's second chapter.

Look for the [Chapter 2 file](./doc/BlueJ-objects-first-ch2.pdf) you need in the [doc](./doc) folder. There is 35 pages of reading and exercises in the chapter.

Work through all these exercises. You edit this file with your answers for these exercises.

* Exercise 2.1 Create a TicketMachine object on the object bench and take a look
at its methods. You should see the following: getBalance, getPrice, insertMoney,
and printTicket. Try out the getPrice method. You should see a return value containing
the price of the tickets that was set when this object was created. Use the
insertMoney method to simulate inserting an amount of money into the machine and
then use getBalance to check that the machine has a record of the amount inserted.
You can insert several separate amounts of money into the machine, just like you might
insert multiple coins or notes into a real machine. Try inserting the exact amount
required for a ticket. As this is a simple machine, a ticket will not be issued automatically,
so once you have inserted enough money, call the printTicket method. A
facsimile ticket should be printed in the BlueJ terminal window.

* Exercise 2.2 What value is returned if you check the machine’s balance after it
has printed a ticket?

*0*

* Exercise 2.3 Experiment with inserting different amounts of money before printing
tickets. Do you notice anything strange about the machine’s behavior? What happens
if you insert too much money into the machine – do you receive any refund? What
happens if you do not insert enough and then try to print a ticket?

*You can put any amount including nothing and you get a ticket and you also get no change.*

* Exercise 2.4 Try to obtain a good understanding of a ticket machine’s behavior by
interacting with it on the object bench before we start looking at how the
TicketMachine class is implemented in the next section.

* Exercise 2.5 Create another ticket machine for tickets of a different price. Buy a
ticket from that machine. Does the printed ticket look different?

*Just the price is different.*

* Exercise 2.6 Write out what you think the outer wrappers of the Student and
LabClass classes might look like – do not worry about the inner part.

*public class Student
public class LabClass*

* Exercise 2.7 Does it matter whether we write
`public class TicketMachine`
or
`class public TicketMachine`
in the outer wrapper of a class? Edit the source of the TicketMachine class to
make the change and then close the editor window. Do you notice a change in the
class diagram?

*Red error messages pop up and there are grid lines in the box of the class*

What error message do you get when you now press the Compile button?

*<identifier> expected*

Do you think
this message clearly explains what is wrong?

*Yes, it states that the public identifier is missing*

* Exercise 2.8 Check whether or not it is possible to leave out the word public
from the outer wrapper of the TicketMachine class.

*It is, no error message.*

* Exercise 2.9 From your earlier experimentation with the ticket machine objects
within BlueJ you can probably remember the names of some of the methods –
printTicket, for instance. Look at the class definition in Code 2.1 and use this
knowledge, along with the additional information about ordering we have given you,
to try to make a list of the names of the fields, constructors, and methods in the
TicketMachine class. Hint: There is only one constructor in the class.

*Fields: price, balance, total
Constructor: TicketMachine
Methods: getPrice, getBalance, insertMoney, printTicket*

* Exercise 2.10 Do you notice any features of the constructor that make it significantly
different from the other methods of the class?

*It is the same name as the class and it does not have a return type listed.*

* Exercise 2.11 What do you think is the type of each of the following fields?
```
private int count;

*an int variable*

private Student representative;

*an object variable of class Student*

private Server host;

*an object variable of class Server*
```
* Exercise 2.12 What are the names of the following fields?
```
private boolean alive;

*alive*

private Person tutor;

*tutor*

private Game game;

*game*

```
* Exercise 2.13 In the following field declaration from the TicketMachine class
```
private int price;
```
does it matter which order the three words appear in? Edit the TicketMachine class to
try different orderings. After each change, close the editor. Does the appearance of the
class diagram after each change give you a clue as to whether or not other orderings are
possible? Check by pressing the Compile button to see if there is an error message.
Make sure that you reinstate the original version after your experiments!

*int private price; it is clear there is an error before compiling.*


* Exercise 2.14 Is it always necessary to have a semicolon at the end of a field declaration?
Once again, experiment via the editor. The rule you will learn here is an
important one, so be sure to remember it.

*yes, you need a ; at the end of a field declaration.*

* Exercise 2.15 Write in full the declaration for a field of type int whose name is
status.

*private int status;*

* Exercise 2.16 To what class does the following constructor belong?
```
public Student(String name)
```
*Class: Student*

* Exercise 2.17 How many parameters does the following constructor have and what are their types?
```
public Book(String title, double price)
```

*2 parameters: a string and a double*

* Exercise 2.18 Can you guess what types some of the Book class’s fields might be? Can you assume anything about the names of its fields?

*there will most likely be a string and a double field that have names similar to title and price.*

Work all Exercises from 2.19 to 2.58 that are NOT marked *Challenge exercise*.

* 2.19
*```
public Pet(String petsName) {
  name = petsName;
}
```*

* 2.20
*price has int in front of it, it's unnecessary since ticketCost is already defined as an int.  This version will still compile, but when you create an object the price is not stored because adding int to price created a new different local variable than the original price variable.*

* 2.21
*the only difference is what they're returning, price vs balance.*

* 2.22
*How much money have I inserted?*

* 2.23
*No, but it might be confusing to read later since amount is referred to in a different method.*

* 2.24
*public int getTotal()
    {
        return total;
    }*

* 2.25
*Error message: Missing return statement.*

* 2.26
*the return type: void vs int*

* 2.27
*No, because their return type is void which means they will not return anything.*

* 2.29
*We know it's a method and not a constructor because of the return value of void.  Constructors don't have return values.*

* 2.30
```
public void setPrice(int newPrice)
    {
        price = newPrice;
    }
    ```

* 2.31
```
public void increase(int points)
{
  score = score + points;
}
```

* 2.32
```
public void discount(int amount)
{
  price = price - discount;
}
```

* 2.33
```
public void prompt()
    {
        System.out.println("Please insert the correct amount of money.");
    }
    ```

* 2.34
```
public void showPrice()
    {
        System.out.println("The price of a ticket is " + price + " cents.");
    }
    ```

* 2.35
*Different outputs because each object has it's own price.*

* 2.36
*It would just write the word price instead of listing the value of the price since putting it in double quotations makes it a string.*

* 2.37
*same as above.*

* 2.38
*No, because both versions would not show a price value it would just say the word price.*

* 2.39
*Initially all objects you make will be the exact same (same state), but you could change the price of objects using newPrice which would make the objects different.*

* 2.40
```
public void empty()
    {
        total = 0;
    }
    ```
    *It does not need any parameters.  It is a mutator.*

* 2.41
*This is a mutator.*

* 2.42
```
public TicketMachine()
{
    price = 1000;
    balance = 0;
    total = 0;
}

public TicketMachine(int ticketPrice)
{
    price = ticketPrice;
    balance = 0;
    total = 0;
}
```

* 2.43
*No, the balance doesn't change when an error message is issued.  If you input 0 there would be an error message because it's > than not >=.*

* 2.44
*If you input 0 you will no longer get an error, the balance will simply remain at 0.*

* 2.45
*isVisible was the boolean, which is appropriate since there are only two options, visible and not visible.*

* 2.46
*Before printing a ticket it confirms enough money has been paid otherwise it lets them know how much more needs to be paid*

* 2.47
*No, the balance could not be negative because the conditional statement does not allow a ticket to be printed unless there is sufficient funds.*

* 2.49
```
int discount;
int saving = price * discount;
```

* 2.50
```
int count;
int mean = total / count;
```

* 2.51 & 2.52
```
public void checkBudget(int budget) {
  if(price > budget) {
    System.out.println("Too expensive! Your budget is only " + budget);
  } else {
    System.out.println("Just Right!");
  }
}
```

* 2.53
*It would always return 0 since it is returning the balance which is set to 0 at the start of the method.*

* 2.54
*return has to be the final command.*

* 2.55
```
public int emptyMachine()
    {
        int finalTotal = total;
        total = 0;
        return finalTotal;
    }
    ```

* 2.56
*It's both, it returns the value of the total as well as then resetting the total.*

* 2.57
```
public void printTicket()
   {
     //New local variable
       int amountLeftToPay = price - balance;

       if(amountLeftToPay <= 0) {
       System.out.println("##################");
       System.out.println("# The BlueJ Line");
       System.out.println("# Ticket");
       System.out.println("# " + price + " cents.");
       System.out.println("##################");
       System.out.println();

       // Update the total collected with the balance.
       total = total + balance;
       // Update the balance.
       balance = balance - price;
   } else {
       System.out.println("You must insert at least: " + amountLeftToPay + " cents.");

   }
}
```

* 2.58
*It depends how many ticket options you want.  The more ticket options the more that would need to be changed.*


READ upto and INCLUDING section 2.15 of this chapter.
